{% extends "users/userspace.html" %}


{% block scripts %}

<link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/css/select2.min.css" rel="stylesheet">
<script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.13/js/select2.min.js"></script>

<script>
    $(document).ready(function() {
        $('.select2').select2();
        $.ajax({
            url: '/account/get_all_users',
            success: function(data) {
                data.unshift({ id: '', text: 'Tous les utilisateurs' });
                $('#user_id_input').select2({
                    data: data
                });

                var selectedValue = "{{ request.GET.user_id }}";
                if (selectedValue) {
                    $('#user_id_input').val(selectedValue).trigger('change');
                }
            }
        });
    });
</script>

<script>
    $("#ferme_filter_select").val("{{ request.GET.ferme }}");
    $("#contrat_id").val("{{ request.GET.contrat }}");
</script>

<script>
    $(document).ready(function() {
        // Fonction pour basculer entre les états
        function toggleEditButtons($container) {
            var operationId = $container.attr('operation_id');
            $container.find('.edit-link').toggle();
            $container.find('.cancel-link').toggle();
            $container.find('.save-link').toggle();
            $('#select_statut_' + operationId).toggle();
            $('#label_statut_' + operationId).toggle();
            $('#select_mode_paiement_' + operationId).toggle();
            $('#label_mode_paiement_' + operationId).toggle();
        }

        $('.edit-link').click(function(event) {
            event.preventDefault();
            var $container = $(this).closest('.edit-buttons');
            toggleEditButtons($container);
        });

        $('.cancel-link').click(function(event) {
            event.preventDefault();
            var $container = $(this).closest('.edit-buttons');
            toggleEditButtons($container);
        });
    });
</script>

{% endblock %}

{% block content %}
    <div class="mx-5 my-5">
        
        <div class="row"> 
            <div class="col">
                <h1 class="mb-3">Liste des paiements enregistrés</h1>
            </div>
            <div class="col text-end">
                <a class="btn btn-secondary me-4"
                    href="{% url 'payments_csv' %}?{{ request.GET.urlencode }}"
                    target="_blank">
                    <i class="fas fa-file-csv me-2"></i>
                    Export CSV
                    </a>
            </div>
        </div>

        <form method="get" action="" class="d-flex flex-wrap">
            <div class="row w-100">
                <div class="col-1 d-flex align-items-center justify-content-center">
                    <button class="btn btn-secondary" type="submit"><i class="fas fa-filter me-2"></i>Filtrer</button>
                </div>
                <div class="col">
                    <div class="row w-100">
                        <div class="col">
                        <label for="user_email_filter_input" class="me-2">Filtrer par utilisateur :</label>
                        <select class="form-control select2" id="user_id_input" name="user_id" style="width: 25em;"></select>
                    </div>
                    </div>
                    <div class="row w-100 my-2">
                        <div class="col">
                        <label for="ferme_filter_select" class="me-2">Filtrer par organisation :</label>
                        <select class="form-control select2 my-2" id="ferme_filter_select" name="ferme" style="width: 15em;">
                            <option value="">Toutes les fermes</option>
                            <option value="AMAP">INS'AMAP</option>
                            {% for ferme in fermes %}
                                <option value="{{ ferme.id }}">{{ ferme.nom }}</option>
                            {% endfor %}
                        </select>
                        </div>
                    </div>
                    <div class="row w-100 align-items-center">
                        <label for="contrat_id" class="col-md-auto me-2">Filtrer par numéro de contrat :</label>
                        <div class="col">
                            <input type="number" min="0" id="contrat_id" name="contrat" class="form-control my-2" style="width:10em;"/>
                        </div>
                    </div>
                </div>
            </div>
        </form>

        {% if success %}
            <div class="alert alert-success alert-dismissible fade show" role="alert">
                Opération modifiée avec succès
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
        {% endif %}

        {% if error %}
            <div class="alert alert-danger alert-dismissible fade show" role="alert">
                Une erreur est survenue lors de la modification de l'opération
                <button type="button" class="btn-close" data-bs-dismiss="alert" aria-label="Close"></button>
            </div>
        {% endif %}

        {% pagination_widget operations request %}

        <div class="table-responsive mb-3">
        <table class="table table-striped table-hover align-middle">
            <thead>
            <tr>
                <th class="pe-2">
                    Date d'enregistrement
                </th>
                <th class="pe-2">
                    De
                </th>
                <th class="pe-2">
                    Vers
                </th>
                <th class="pe-2">
                    Contrat
                </th>
                <th class="pe-2">
                    Montant
                </th>
                <th class="pe-2">
                    Libellé
                </th>
                <th class="pe-2 text-center">
                    Statut
                </th>
                <th class="pe-2 text-center">
                    Moyen de paiement
                </th>
                <th class="pe-2 text-center">
                    Actions
                </th>
            </tr>
            </thead>
            <tbody>
            {% for operation in operations %}
                <tr id="op_{{operation.id}}">
                    <form method="post" action="#op_{{operation.id}}">
                        {% csrf_token %}
                    <input type="hidden" name="operation_id" value="{{operation.id}}"/>
                        <td class="pe-2">
                            {{ operation.date_enregistrement|date:"d/m/Y" }}
                        </td>
                        <td class="pe-2">
                            {% if operation.montant > 0 %}
                                {% if operation.utilisateur %}
                                {{ operation.utilisateur.last_name }} {{ operation.utilisateur.first_name }} <br>
                                    <a href="{% url 'user_details_admin' operation.utilisateur.id %}"
                                        target="_blank">
                                        {{ operation.utilisateur.email }}
                                    </a>
                                {% else %}
                                    Utilisateur supprimé
                                {% endif %}
                            {% else %}
                                {% if operation.ferme is None %}
                                    INS'AMAP
                                {% else %}
                                    <a href="{% url 'farm_details_admin' operation.ferme.id %}" target="_blank">
                                        {{ operation.ferme.nom }}
                                    </a>
                                {% endif %}
                            {% endif %}
                        </td>
                        <td class="pe-2">
                            {% if operation.montant > 0 %}
                                {% if operation.ferme is None %}
                                    INS'AMAP
                                {% else %}
                                    <a href="{% url 'farm_details_admin' operation.ferme.id %}" target="_blank">
                                        {{ operation.ferme.nom }}
                                    </a>
                                {% endif %}
                            {% else %}
                                {% if operation.utilisateur %}
                                    <a href="{% url 'user_details_admin' operation.utilisateur.id %}"
                                        target="_blank">
                                        {{ operation.utilisateur.email }}
                                    </a>
                                {% else %}
                                    Utilisateur supprimé
                                {% endif %}
                            {% endif %}
                        </td>
                        <td class="pe-2 text-center">
                            {% if operation.contrat is not None %}
                                <a href="{% url 'contrat_details' operation.contrat.id %}" target="_blank">
                                    {{ operation.contrat.id }}
                                </a>
                            {% else %}
                            -
                            {% endif %}
                        </td>
                        <td class="pe-2 text-center">
                            {{ operation.montant|floatformat:2 }} €
                        </td>
                        <td class="pe-2">
                            {{ operation.libelle }}
                        </td>
                            
                        <td class="pe-2 text-center">
                            <div id="label_statut_{{operation.id}}">
                                {{ operation.get_status_label }}
                            </div>
                            <select class="form-control select-status" id="select_statut_{{operation.id}}" name="statut" style="display: none;">
                                <option value="1" {% if operation.statut == 1 %} selected {% endif %}>Opération enregistrée</option>
                                <option value="2" {% if operation.statut == 2 %} selected {% endif %}>Marquée payée par l'utilisateur</option>
                                <option value="3" {% if operation.statut == 3 %} selected {% endif %}>Payé à l'AMAP</option>
                                <option value="4" {% if operation.statut == 4 %} selected {% endif %}>Payé à la ferme</option>
                            </select>                        
                        </td>
                        <td class="pe-2 text-center">
                            <div id="label_mode_paiement_{{operation.id}}">
                                {{ operation.get_paiement_label }}
                            </div>
                            <select class="form-control select-mode-paiement" id="select_mode_paiement_{{operation.id}}" name="mode-paiement" style="display: none;">
                                <option value="" {% if operation.mode_paiement == "" %} selected {% endif %}>Aucun</option>
                                <option value="1" {% if operation.mode_paiement == 1 %} selected {% endif %}>Carte Bancaire</option>
                                <option value="2" {% if operation.mode_paiement == 2 %} selected {% endif %}>Espèces</option>
                                <option value="3" {% if operation.mode_paiement == 3 %} selected {% endif %}>Chèque</option>
                                <option value="4" {% if operation.mode_paiement == 4 %} selected {% endif %}>Virement</option>
                            </select>                        
                        </td>
                        <td class="pe-2 text-center">
                            <span class="edit-buttons" operation_id="{{operation.id}}">
                                <a class="btn btn-link edit-link">Modifier</a>
                                <a class="btn btn-link cancel-link" style="color: red; display: none;">Annuler</a>
                                <button class="btn btn-link save-link" type="submit" style="color: green; display: none;">Enregistrer</button>
                            </span>
                            
                        </td>
                    </form>
                </tr>
            {% endfor %}
            {% if operations|length == 0 %}
            <tr>
                <td colspan="9" class="text-center">
                Aucun résultat
                </td>
            </tr>
            {% endif %}
            </tbody>
        </table>
    </div>

    {% pagination_widget operations request %}

    </div>
{% endblock %}